
-- block
-- that has a question

freeslot("S_SMB_FIREFLOWER", "MT_SMB_FIREFLOWER")

states[S_SMB_FIREFLOWER] = {
    sprite = SPR_MBPU,
    frame = C|FF_ANIMATE,
    tics = -1,
    var1 = 3,
	var2 = 3
}

mobjinfo[MT_SMB_FIREFLOWER] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_SMB_FIREFLOWER,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	deathsound = sfx_null,
	radius = 8*FU,
	height = 16*FU,
	flags = MF_SPECIAL
}

addHook("MobjThinker", function(mo)
	if netplay
	and displayplayer
		local p = displayplayer
		if skins[p.skin].name ~= "smbmario"
			mo.flags2 = $1|MF2_DONTDRAW
		else
			mo.flags2 = $ & ~MF2_DONTDRAW
		end
	end
end, MT_SMB_FIREFLOWER)

addHook("TouchSpecial", function(mo, pmo)
	if netplay
	and pmo.skin ~= "smbmario" then return true end
	
	if pmo.player.smbpowerup < 2
		pmo.player.smbgetpowerup = true
	end
	P_AddPlayerScore(pmo.player, 1000)
	local score = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
	score.scale = mo.scale
	score.tics = TICRATE
	score.momz = 5*FU
	score.sprite = SPR_MBSC
	score.frame = F
end, MT_SMB_FIREFLOWER)

-- fire ball stuff!!
addHook("MobjMoveBlocked", function(fb)
	if not fb.smbfireball then return end
	
	fb.smbbumped = true
	P_KillMobj(fb)
end, MT_FIREBALL)

local function death(fb)
	if not fb.smbfireball then return end
	
	local o = P_SpawnMobj(fb.x, fb.y, fb.z, MT_THOK)
	if fb.smbbumped
		S_StartSound(o, sfx_smbbmp)
	end
	o.state = S_SMB_FIREBALLDEAD
	o.spritexscale = fb.spritexscale
	o.spriteyscale = fb.spriteyscale
	fb.target.player.smbfblimit = $-1
end

--addHook("MobjDeath", death, MT_FIREBALL)
addHook("MobjRemoved", death, MT_FIREBALL)